#ifndef CFILEINFO_H
#define CFILEINFO_H
///////////////////////////////////////////////////////////////
//                                                           //
//  CFileInfo.h -  Analyze the include information of a file //
//  ver 1.0        sorted list of files.                     //                                          //
//                                                           //
//  Language:      Visual C++, ver 6.0                       //
//  Platform:      Micron Dual Pentium 200, Windows NT 4.0   //
//  Application:   CSE687 Project #1, S99                    //
//  Author:        Jin,Jianxiang           (315) 443-4889    //
//                 jjin@npac.syr.edu                         //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Manual Page
    -----------

    class CFileInfo Operations:
    -------------------------
	Find out all files which this file includes,then add these
	file names to a list

    Contructor & Decontructor
		CFileInfo(const char * _filename);
		~CFileInfo();

    Add all names of files which  strFileName includes
		void makeIncludeList();	

	Get the list of included file names 
		ROW  getList();


*/

//

///////////////////////////////////////////////////////////////
//                      maintenance page                     //
///////////////////////////////////////////////////////////////
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//     CFileInfo.h CFileInfo.cpp Basic.h                     //
//                                                           //
//  Building with Visual C++ , ver 6.0, from command line:   //
//    cl -GX -DTEST_CFILEINFO  CFileInfo.cpp                 //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 1.0 : 07 Feb 99
        - first release



*/

//

///////////////////////////////////////////////////////////////
//                         Declarations                      //
///////////////////////////////////////////////////////////////
#include <iostream>
#include "Basic.h"



class CFileInfo{
	char * strFileName;  // store the file name
	ROW    rIncludeList; // this list includes all file names which strFileName includes

public :
    //Contructor 
	CFileInfo(const char * _filename);

	//Decontructor
	~CFileInfo();

    //add all names of files which  strFileName includes
	void makeIncludeList();	

	//return the list of file names 
	ROW  getList();

private :	
	// if s includes '#',return true, otherwise return false
	bool foundHash(const string &s);

	bool foundDelim(const string &s,int &pos);

	string extractName(const string &s,int pos);
};


#endif

