#ifndef CFILEPATTERN_H
#define CFILEPATTERN_H
///////////////////////////////////////////////////////////////
//                                                           //
//  CFilePattern.h - Analyze the file pattern inputed by user//
//  ver 1.0					then find the releated files     //                                          //
//                                                           //
//  Language:      Visual C++, ver 6.0                       //
//  Platform:      Micron Dual Pentium 200, Windows NT 4.0   //
//  Application:   CSE687 Project #1, S99                    //
//  Author:        Jin,Jianxiang           (315) 443-4889    //
//                 jjin@npac.syr.edu                   //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Manual Page
    -----------

    class CFilePattern Operations:
    -------------------------
	this class analyze the file pattern, then add all files
	related  to a list.

	Contructor & Deconstructor		
		CFilePattern(const char *filemask);	
		~CFilePattern();


	Make a list of file names according the input file pattern
		bool makeFileNameList();


	Get the list which contains the list of file names
		ROW  getList();


*/

//

///////////////////////////////////////////////////////////////
//                      maintenance page                     //
///////////////////////////////////////////////////////////////
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//    CFilePattern.h CFilePattern.cpp, Basic.h               //
//                                                           //
//  Building with Visual C++ , ver 6.0, from command line:   //
//    cl -GX -DTEST_CFILEPATTERN CFilePattern.cpp            //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 1.0 : 05 Feb 99 
	  - first release



*/

//

///////////////////////////////////////////////////////////////
//                         Declarations                      //
///////////////////////////////////////////////////////////////

#include <iostream>
#include "Basic.h"



class CFilePattern{
private:
	char * pFileMask; // store the file pattern. 
	ROW	 rFileNames;  // store the names of files related to file pattern pFileMask.

public :
	//contructor 
	CFilePattern(const char *filemask);

	//deconstuctor
	~CFilePattern();

	//add all names of files to a  list
	bool makeFileNameList();

	//return the file name list
	ROW  getList();
private :
	//auxiliary fuction of makeFileNameList.
	void addFileToList(char * dirName);
};

#endif


