#ifndef CGRID_H
#define CGRID_H
///////////////////////////////////////////////////////////////
//                                                           //
//  CGrid.h   -    Support some operations of GRID,which is  //
//  ver 1.0        vector of vector of string.               //                                          
//                 These operations include :                //
//  Language:      Visual C++, ver 6.0                       //
//  Platform:      Micron Dual Pentium 200, Windows NT 4.0   //
//  Application:   CSE687 Project #1, S99                    //
//  Author:        Jin,Jianxiang           (315) 443-4889    //
//                 jjin@npac.syr.edu						 //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Manual Page
    -----------

	keywords:
	-------------------------
		ROW       : define as vector<string>
		GRID      : define as vector<vector<string>>
		Dependece : For any j, if GRID[i][j] == GRID[z][0] ,then GRID[i] dependent on GRID[z];

	class CGrid  Data:
	-------------------------
		GRID  gGrid;

		
    class CGrid  Operations:
    -------------------------
	Public :
	Contructor:
		CGrid();

    Deconstructor:
		~CGrid();

    Swap two rows: row1 and row2 
		void Swap(int row1,int row2);

	Add a new element to the end of gGird
		void Push(ROW r);

    Merge :for every element of gGrid in this class,say GRID[i][j],if GRID[i][j]==GRID[z][0],
		then in GRID[i],replace GRID[i][j] by all element in GRID[z]; Obviously, this fuction
		is recursive.
		void Merge();

    Display every element of gGrid.
		void Display();

	Sort rows in gGrid by SORT_TYPE. Now I support two types:
	    ALPHABET     : alphabet order
		DEPENDENCE   : dependence order		

		void Sort(SORT_TYPE sortType);	
*/

//

///////////////////////////////////////////////////////////////
//                      maintenance page                     //
///////////////////////////////////////////////////////////////
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//    Basic.h   CGrid.h    CGrid.cpp                         //
//                                                           //
//  Building with Visual C++ , ver 6.0, from command line:   //
//    cl -GX -DTEST_CGRID CGrid.cpp                          //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 1.0 : 05 Feb 99
        - first release



*/

//

///////////////////////////////////////////////////////////////
//                         Declarations                      //
///////////////////////////////////////////////////////////////
#include <iostream>
#include "Basic.h"

using namespace std;

#define SORT_TYPE		int

#define ALPHABET		0
#define DEPENDENCE		1

class CGrid{
private:
	//private data member 
	GRID  gGrid;

public:
	//contructor 
	CGrid();

	//deconstructor
	~CGrid();

    //Swap tow rows.
	void Swap(int row1,int row2);

	//Add a new row 
	void Push(ROW r);

	//Merge the this GRID
	void Merge();
	
	//Display all elements in GRID
	void Display();

    //Sort the GRID,taking ROW as sort unit.
	void Sort(SORT_TYPE sortType);

private :

	// If row r1 dependent on r2, then return TRUE, otherwise, return FALSE;
	bool Dependence(int r1,int r2);
    
	// Replace the element located at GRID[i][j] with these elements in the row numbered rowNum
	void ExtractElement(int i,int j,int rowNum,bool repeatCheck);

	//return the row number of a row whose first element is s
	int  GetIncludeRowNum(string& s);

	//auxiliary fuction of Merge
	void RecursiveExtract(int i,int j);

};

#endif
