///////////////////////////////////////////////////////////////
//                                                           //
//  CMain.cpp     Main file of the project                   //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application:display all file duplicates in a specified	 //
//			   directory and all its sub directories. Also 	 //
//			   provides a functionality to display all files //
//			   under a specified directory and all its		 //
//			   subdirectories.								 //	
//  Author:    Jin,Jianxiang, Syracuse University            //
//				jjin@npac.syr.edu							 //	
//                                                           //
//                    copyright (c) 1999                     //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////

#pragma warning(disable : 4786)
#include <iostream>
#include "Basic.h"
#include "CGrid.h"
#include "CFileInfo.h"
#include "CFilePattern.h"



void main(int argc, char *argv[])
{

	cout<<"\n            Dependence analyzier               \n\n";
	cout<<"						       By   Jin,Jianxiang\n";
	cout<<" 					           jjin@npac.syr.edu\n\n\n";
	cout<<"Notice: the files to be processed should be in the same \ndirectory with this program\n\n\n";
	CGrid cGrid;
	for(int i=1;i<argc;i++){
		// analyze every parameter user inputed
		CFilePattern cFilePattern(argv[i]);
		if(cFilePattern.makeFileNameList()){//convert from file pattern to files
			ROW fileList;
			fileList = cFilePattern.getList();
			int j;
			for(j=0;j<fileList.size();j++){				
				string fileName = fileList[j];
				CFileInfo cFileInfo(fileName.c_str());
				cFileInfo.makeIncludeList();   
				//analyze every file
				cGrid.Push(cFileInfo.getList());
			}
		}
	}	
	cGrid.Merge();
	cout<<"\n------------       Result    ---------------------------\n";
	cGrid.Display();	
}