#ifndef CCleanFile_H
#define CCleanFile_H
///////////////////////////////////////////////////////////////
//                                                           //
//  CleanFile.h -  Delete files of certain types             //
//                 generated by VC                          //
//  ver 1.0        sorted list of files.                     //                                          //
//                                                           //
//  Language:      Visual C++, ver 6.0                       //
//  Platform:      Micron Dual Pentium 200, Windows NT 4.0   //
//  Application:   CSE687 Project #1, S99                    //
//  Author:        Jin,Jianxiang           (315) 443-4889    //
//                 jjin@npac.syr.edu                         //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Manual Page
    -----------

    class CCleanFile Operations:
    -------------------------
	Find out all files which this file includes,then add these
	file names to a list

    Contructor & Decontructor
		CCleanFile(string _root);
		~CCleanFile();
    Function interface used to delete files
		void doCleanFile( vector< vector<CFileNode> >  *_pFileTree);




*/

//

///////////////////////////////////////////////////////////////
//                      maintenance page                     //
///////////////////////////////////////////////////////////////
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//     CFileInfo.h CFileInfo.cpp Basic.h                     //
//                                                           //
//  Building with Visual C++ , ver 6.0, from command line:   //
//    cl -GX -DTEST_CCLEANFILE  CCleanFile.cpp               //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 1.0 : 07 Feb 99
        - first release



*/

//

///////////////////////////////////////////////////////////////
//                         Declarations                      //
///////////////////////////////////////////////////////////////

#include "CFileNode.h"
#include <vector>
#include <string>

using namespace std;

class CCleanFile{
private:
	vector< vector<CFileNode> > *pFileTree;
	//store the root dir name
	string						 rootDirectory; 
	//store the file extensions to be deleted
	vector<string>				 extList; 

	string getFullFileName(CFileNode & _fileNode);
	bool   deleteFile();
	void   printFileTree();
	bool   userDeleteConfirm();
	bool   isToBeDeleted(string ext);
	void   checkFile();		
public :
	CCleanFile(string _root);
    ~CCleanFile();
	void doCleanFile( vector< vector<CFileNode> >  *_pFileTree);

};
#endif
