///////////////////////////////////////////////////////////////
//                                                           //
//  CCleanFileCall.cpp                                         //
//                - derived class of command. Redefine       //
//			  execute() which in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  cleaning() member function in dups class.      //
//			  Act as interface between clients and dups		 // 	
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: derived class of command class. Redefine    //
//			  execute() witch in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  doCleanFile( ) member function in dups class.    //
//			  Act as interface between clients and dups		 // 	
//                                                           //
//                                                           //
//  Author:    Jin,Jianxiang, Syracuse University            //
//				jjin@npac.syr.edu							 //	
//                                                           //
//                    copyright (c) 1999                     //
//                                                           //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////
#pragma warning (disable : 4786)

#include "CNavigator.h"
#include "CCleanFile.h"
#include "CCleanFileCall.h"
#include "CDupFile.h"
#include <iostream>
#include <windows.h>

using namespace std;
//construtor
CCleanFileCall::CCleanFileCall(CCleanFile* ptr, void (CCleanFile::*funcptr)( vector< vector<CFileNode> >  *_pFileTree)):cptr(ptr), fptr(funcptr){
}

//interface
void CCleanFileCall::execute( vector< vector<CFileNode> >  *_pFileTree){
	(cptr->*fptr)(_pFileTree);
}

#ifdef TEST_CCLEANFILECALL
#pragma warning( disable : 4786 )
//----< test stub >--------------------------------------------
void main( ) {
	cout<<"Please input a directory name"<<endl;
	string s;
	cin>>s;
	if(!strcmp(s.c_str(), ".")|| !strcmp(s.c_str(), "..")){

		if(!SetCurrentDirectory(s.c_str()))
			return;
		char buf[256];
		if(!GetCurrentDirectory(256, buf))
			return;
		s = buf;
		cout<<s<<endl;
	}	
	CNavigator n(s);
	n.createFileTree();
	n.printFileTree();
	CCleanFile c(s);
	CCleanFile *pC;
	pC = &c;
	void (CCleanFile::*pFunction)(vector< vector<CFileNode> > *) =CCleanFile::doCleanFile;
	CCleanFileCall _cleanCall(pC,pFunction);			
	n.registCommand(&_cleanCall);
	n.invokeCommand();
}
#endif
