#ifndef CCLEANFILECALL_H
#define CCLEANFILECALL_H

///////////////////////////////////////////////////////////////
//                                                           //
//  CCleanFileCall.h - derived class of command. Redefine    //
//			  execute() which in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  doCleanFile() member function in dups class.   //
//			  Act as interface between clients and dups		 // 	
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: derived class of command class. Redefine    //
//			  execute() witch in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  doCleanFileCall( ) member function in dups class.//
//			  Act as interface between clients and dups		 // 	
//  Author:      Jianxiang Jin Syracuse University          //
//                                                           //
//                    copyright (c) 1999                     //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////
/*


  Module CCLEANFILECALL - derived class of command class. Redefine 
			  execute() witch in the command class is a pure 
			  virtual function. The redefined execute can be 
			  used by  clients as command to callback the    
			  doCleanFile() member function in dups class.   							         
			  Act as interface between clients and dups		 	
  Keywords:
  =========

*/
//

///////////////////////////////////////////////////////////////
//                                                           //
//               Maintenance Page                            //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  Build Process                                            //
//                                                           //
//  Files Required:											 //	
//	node.h, clean.h										     //	
//	Integrated Environment:                                  //
//  - close any open project                                 //
//  - set Options/Compiler/Code generation/defines: to       //
//    TEST_CCLEANFILECALLCPP	                                     //
//  - run                                                    //
//                                                           //
//  Command Line Compiler:                                   //
//    cl     -DTEST_CLEANFILECALL CCleanFileCall.cpp	CCleanFile.cpp//
//                                                           //
///////////////////////////////////////////////////////////////
/*

  Design notes:
  =============

  History:
  ========
  v1.0 : 18 March, 99
*/
///////////////////////////////////////////////////////////////
//                                                           //
//               Declarations                                //
//                                                           //
///////////////////////////////////////////////////////////////
#include "CFileNode.h"
#include "CCleanFile.h"
#include <vector>

using namespace std;

class CCleanFileCall : public CCommand{
private:
	CCleanFile* cptr;
	void (CCleanFile::*fptr)( vector< vector<CFileNode> >  *_pFileTree);

public:
	CCleanFileCall(CCleanFile* ptr, void (CCleanFile::*funcptr)( vector< vector<CFileNode> >  *_pFileTree));
	void execute( vector< vector<CFileNode> >  *_pFileTree);
};

#endif
	
						






