#ifndef CDupFile_H
#define CDupFile_H
///////////////////////////////////////////////////////////////
//                                                           //
//  CDupFile. -    Deal with duplicate files                 //
//  ver 1.0                                                  //                                          //
//                                                           //
//  Language:      Visual C++, ver 6.0                       //
//  Platform:      Micron Dual Pentium 200, Windows NT 4.0   //
//  Application:   CSE687 Project #1, S99                    //
//  Author:        Jin,Jianxiang           (315) 443-4889    //
//                 jjin@npac.syr.edu                         //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Manual Page
    -----------

    class CDupFile         
    -------------------------
	Function Interface used to deal with duplicate files
	void   doDupFile(vector< vector<CFileNode> >* _pFileTree);

*/

//

///////////////////////////////////////////////////////////////
//                      maintenance page                     //
///////////////////////////////////////////////////////////////
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//     CDupFile.h CFileNode.h CSameFileNode.h                //
//                                                           //
//  Building with Visual C++ , ver 6.0, from command line:   //
//    cl -GX -DTEST_CDUPFILE CDupFile.cpp                    //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 1.0 : 07 Feb 99
        - first release



*/

//

///////////////////////////////////////////////////////////////
//                         Declarations                      //
///////////////////////////////////////////////////////////////

#include <vector>
#include <string>
#include "CSameFileNode.h"
#include "CFileNode.h"
#include "iostream"

using namespace std;

class CDupFile{
private:
	vector< vector<CFileNode> >* pFileTree;
	vector< CSameFileNode >*     pSameFileList; 
	string						 rootDirectory; 	
public :
	CDupFile(string _root, vector< CSameFileNode >*   _pSameFileList);
	~CDupFile();	
	
	string getFullFileName(CFileNode& _fileNode);
	void   showDupFile();	
	void   doDupFile(vector< vector<CFileNode> >* _pFileTree);
};

#endif
