///////////////////////////////////////////////////////////////
//                                                           //
//  CDupFileCall.cpp                                         //
//                - derived class of command. Redefine       //
//			  execute() which in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  cleaning() member function in dups class.      //
//			  Act as interface between clients and dups		 // 	
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: derived class of command class. Redefine    //
//			  execute() witch in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  doDupFile( ) member function in dups class.    //
//			  Act as interface between clients and dups		 // 	
//                                                           //
//                                                           //
//  Author:    Jin,Jianxiang, Syracuse University            //
//				jjin@npac.syr.edu							 //	
//                                                           //
//                    copyright (c) 1999                     //
//                                                           //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////
#pragma warning (disable : 4786)

#include "CNavigator.h"
#include "CCleanFile.h"
#include "CCleanFileCall.h"
#include "CDupFileCall.h"
#include "CDupFile.h"
#include <iostream>
#include <windows.h>

using namespace std;
//constructor of CDupFileCall
CDupFileCall::CDupFileCall(CDupFile* ptr, void (CDupFile::*funcptr)(vector< vector<CFileNode> >* _pFileTree)):cptr(ptr), fptr(funcptr){
}


//interface
void CDupFileCall::execute(vector< vector<CFileNode> >* _pFileTree){
	(cptr->*fptr)(_pFileTree);
}
#ifdef TEST_CDUPFILECALL
#pragma warning( disable : 4786 )
//----< test stub >--------------------------------------------
void main( ) {
	cout<<"Please input a directory name"<<endl;
	string s;
	cin>>s;
	if(!strcmp(s.c_str(), ".")|| !strcmp(s.c_str(), "..")){

		if(!SetCurrentDirectory(s.c_str()))
			return;
		char buf[256];
		if(!GetCurrentDirectory(256, buf))
			return;
		s = buf;
		cout<<s<<endl;
	}	
	CNavigator n(s);
	n.createFileTree();
	n.printFileTree();
	CDupFile d(s,n.getSameFileList());
	CDupFile * pD = &d;
	void (CDupFile::*pDFunction)(vector< vector<CFileNode> > *) =CDupFile::doDupFile;
	CDupFileCall _dupCall(pD,pDFunction);			
	n.registCommand(&_dupCall);
	n.invokeCommand();
}
#endif
