#ifndef CDUPFILECALL_H
#define CDUPFILECALL_H

///////////////////////////////////////////////////////////////
//                                                           //
//  CDupFileCall.h- derived class of command. Redefine       //
//			  execute() which in the command class is a pure //
//			  virtual function.                              //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: derived class of command class. Redefine    //
//			  execute() witch in the command class is a pure //
//			  virtual function. The redefined execute can be //
//			  used by  clients as command to callback the    //
//			  cleaning( ) member function in dups class.     //
//			  Act as interface between clients and dups		 // 	
//  Author:      Jianxiang  Jin Syracuse University          //
//                                                           //
//                    copyright (c) 1999                     //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////
/*


  Module CDUPFILECALL - derived class of command class. Redefine 
			  execute() witch in the command class is a pure 
			  virtual function. The redefined execute can be 
			  used by  clients as command to callback the    
			  doDupFile() member function in dups class.   							         
			  Act as interface between clients and dups		 	
  Keywords:
  =========

*/
//

///////////////////////////////////////////////////////////////
//                                                           //
//               Maintenance Page                            //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  Build Process                                            //
//  CFileNode.h CSameFileNode.h CDupFile.h,CDupFile.cpp      //
//	CDupFileCall.h CDupFileCall.cpp                          //
//  Files Required:											 //	
//                                                           //
//                                                           //
//  Command Line Compiler:                                   //
//    cl  -DTEST_CDUPFILECALL  CDupFileCall.cpp CDupFile.cpp //
//                                                           //
///////////////////////////////////////////////////////////////
/*

  Design notes:
  =============

  History:
  ========
  v1.0 : 18 March, 99
*/
///////////////////////////////////////////////////////////////
//                                                           //
//               Declarations                                //
//                                                           //
///////////////////////////////////////////////////////////////
#include "CFileNode.h"
#include "CSameFileNode.h"
#include "CDupFile.h"
#include <vector>

using namespace std;

class CDupFileCall : public CCommand{
private:
	CDupFile* cptr;
	void (CDupFile::*fptr)(vector< vector<CFileNode> >* _pFileTree);
public:	

	CDupFileCall(CDupFile* ptr, void (CDupFile::*funcptr)(vector< vector<CFileNode> >* _pFileTree));
	void execute(vector< vector<CFileNode> >* _pFileTree);
};

#endif
	
						






