#ifndef CNAVIGATOR_H
#define CNAVIGATOR_H

#include <vector>
#include <string>
#include <iostream>
#include <windows.h>
#include "CCommand.h"
#include "CFileNode.h"
#include "CSameFileNode.h"

using namespace std;

class CNavigator{
private:
	vector<vector<CFileNode> >		fileTree;
	vector<CSameFileNode>			sameFileList;
	
	vector<CCommand *>				commandList;
	string							rootDirectory;

	
	
	void traverseDirectory(char *dirName,char *fileMask, int* level,int parentIndex,vector<int>* pIndexNO);
	void putFindFileInfo(WIN32_FIND_DATA *findData,int* level,int index,int parentIndex);
	void updateFileTree(WIN32_FIND_DATA *findData,int* level,int index,int parentIndex);
	void updateSameFileList(WIN32_FIND_DATA *findData,int* level,int index,int parentIndex);	

public:
	CNavigator();
	CNavigator(string _rootDirectory);
	~CNavigator();

	void registCommand(CCommand*);
	void invokeCommand();
	void printSameFileList();
	void createFileTree();
	void printFileTree();
	vector< vector<CFileNode> >*	getFileTree();
	vector<CSameFileNode>*			getSameFileList();
};
#endif
