///////////////////////////////////////////////////////////////
//                                                           //
//  Sweep.cpp    Main file of the project                   //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//                                                           //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//                                                           //
//  Application: Clean the files generated					 //
//               by Visual C++                               //
//               and display informatino about duplicate     //
//               files                                       //
//                                                           //
//                                                           //
//  Author:    Jin,Jianxiang, Syracuse University            //
//				jjin@npac.syr.edu							 //	
//                                                           //
//                    copyright (c) 1999                     //
//                                                           //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////

#pragma warning(disable : 4786)

#include "CNavigator.h"
#include "CCleanFile.h"
#include "CCleanFileCall.h"
#include "CDupFile.h"
#include "CDupFileCall.h"


using namespace std;

void main(){
	cout<<"\n\n             Sweep  Program\n"<<"\n\n                     by   Jin,Jianxiang\n\n                          jjin@npac.syr.edu\n\n\n"<<"Please input a directory name(like: c:\\jin)\n";
	string s;	cin>>s;
	if(!strcmp(s.c_str(), ".")|| !strcmp(s.c_str(), "..")){
		char buf[256];
		if(!SetCurrentDirectory(s.c_str())  || !GetCurrentDirectory(256, buf))
			return;
		s = buf;
	}
	//constructor a object of class CNavigator
	CNavigator n(s);	
	n.createFileTree();
	//constructor a object of class CCleanFile
	CCleanFile c(s);
	CCleanFile * pC = &c;
	void (CCleanFile::*pCFunction)(vector< vector<CFileNode> > *) =CCleanFile::doCleanFile;
	CCleanFileCall _cleanCall(pC,pCFunction);			
	//constructor a object of class CDupFile
	CDupFile d(s,n.getSameFileList());
	CDupFile * pD = &d;
	void (CDupFile::*pDFunction)(vector< vector<CFileNode> > *) =CDupFile::doDupFile;
	CDupFileCall _dupCall(pD,pDFunction);			
	cout<<"Please regist command  now:\n c(or C) for clean; d(or D)for dup; y(or Y) for end regist\n";
	string cmd=" "; 	
	//user interface  provided to regist command and then execute them
	while(cmd!="y" && cmd!="Y"){
		cout<<"Command Regist>";
		cin>>cmd; cmd = cmd.substr(cmd.length()-1,cmd.length());		
		if(cmd =="c" || cmd=="C")
			n.registCommand(&_cleanCall);
		else if (cmd =="d" || cmd =="D")
				n.registCommand(&_dupCall);

	}
	n.printFileTree();	
	n.invokeCommand();
	n.printFileTree();
	return;
}


