#ifndef CTUTOR_H
#define CTUTOR_H

///////////////////////////////////////////////////////////////
//                                                           //
//  CTutor.h     Tutor provide query for user from a file    //
//               by some keywords                            //
//  v1.0                                                     //
//               Manual Page                                 //
//                                                           //
//  Language:    Visual C++, ver 6.0                         //
//  System:      Window NT, DOS 6.2                          //
//  Application: user input some keyword, then tutor         //
//			     can return the query result                 //
//                                                           //
//                                                           //
//  Author:      Jianxiang Jin Syracuse University           //
//                                                           //
//                    copyright (c) 1999                     //
//    all rights granted to users except right to publish    //
//                                                           //
///////////////////////////////////////////////////////////////
/*


  Module CCLEANFILECALL - derived class of command class. Redefine 
			  execute() witch in the command class is a pure 
			  virtual function. The redefined execute can be 
			  used by  clients as command to callback the    
			  doCleanFile() member function in dups class.   							         
			  Act as interface between clients and dups		 	
  Keywords:
  =========

*/
//

///////////////////////////////////////////////////////////////
//                                                           //
//               Maintenance Page                            //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  Build Process                                            //
//                                                           //
//  Files Required:											 //	
//	CTutor.h CTutor.cpp                 				     //	
//	Integrated Environment:                                  //
//                                                           //
//  Command Line Compiler:                                   //
//    cl     -DTEST_CTUTOR    CTutor.cpp                     //
//                                                           //
///////////////////////////////////////////////////////////////
/*

  Design notes:
  =============

  History:
  ========
  v1.0 : 18 March, 99
*/
///////////////////////////////////////////////////////////////
//                                                           //
//               Declarations                                //
//                                                           //
///////////////////////////////////////////////////////////////


#include <vector>
#include <string>
#include <map>
#include <utility>
#include <iostream>
#include <fstream>
#include "CBlockNode.h"

using namespace std;

#define _NONE    -1					
#define _KEY     0					
#define _TITLE   1
#define _TEXT    2 					

typedef vector<CBlockNode>  VCB;
typedef vector<int>			VI;
typedef map<string,VI>		JMAP;
typedef map<int,int>		HITMAP;//map<bloackid,hittimes>

class CTutor{
private:
	vector<string>	keywordList;//keywords user input for search
	JMAP			keywordToBlock;
	HITMAP			blockHitTimes;
	VCB				blockList;
	vector<int>		topVector;//store the index of top blocks	


	void resetList();
	void readInputKeywords();
	void readDataFile();
	void displayResult(int _NO);
	void doSearch();
	void printOutHitList();
	void printOutBlock(int _no,bool titleOnly);
	void addMap(string _key,int _nodeID);
	void addHitTimes(int _nodeID);
	int  getMaxValueIndex(int _max,bool _less);	
	bool isNewBlock(int _index);
	string readFileNameFromUser();
	void doReadText(CBlockNode* pTempNode,string buf,int _state,int _id);	
	bool isTitleLine(int* pID,string buf,int* pState,CBlockNode* pNode);
	vector<string>  stringToWords(string _input);
public :
	CTutor();	
	~CTutor();
	void doTutor();
};

#endif